/*
nameNames -Start at page bottom 
copyright 2010 Chris Glasier 
code check JSLint outstanding
*/

/*global config,nset,corePlainSlider,coreConfirmHide,coreShutter,interSelect,interViews,interHilites,interRename,interSync,coreSetup,coreRun2,coreInput,coreSupportFiles,coreCleanup 
*/

function fList(name){
var list;	
	switch(name){
	case "Main"			: list = ["Interactors","ShowHide","Style","Menu","Settings","Help"]; break;
	case "Interactors"	: list = ["Views","Hilites","Sync","Rename"]; break;
	case "Help"			: list = ["Purpose","Links","Interactors","Menu","ShowHide","Style","Settings"]
	}
	return(list);
}

function fPass(ents, nr, pass, ft){
	var nt,fn;
	pass += 1;
	if(ents[pass] === undefined){
		return;
	}
	nr = ents[pass];
	if(nset[nr].Forelink){
		fCompile(ents , nr , pass, ft);
	}
	else{
		fPass(ents, nr, pass, ft);
	}
}

function fCompile(ents, nr, pass, ft){
	var cell, k, kk;
	nr	= ents[pass];
	k	= nset[nr].Forelink; 
	for(kk = 0; kk < k.length; kk += 1){
		cell = document.getElementById("n"+k[kk]);
		if(ft === 1){
			nset[k[kk]].Filter = "Filtered";
		}
		else{
			delete nset[k[kk]].Filter;
		}	
		ents.push(k[kk]);
	}
	fPass(ents,  nr, pass, ft);
}

function fLeader( nr, nt){
	var ents, pass, cell, ft;
	pass = 0;
	ents = [nr]; 
	cell = document.getElementById("n"+nr);
	ents[pass] = [nr]; 
	if(!nset[nr].Filter){
		nset[nr].Filter = "Filtered";
		ft = 1;
	}
	else{
		delete nset[nr].Filter;
		ft = 0;
	}	
	if(!nset[nr].Forelink){
		nt = config.nametrail;
		fn = nt[nt.length-1][2];
		coreJsonSave(fn + ".json", nset);
		return;
	}
	else{
		fCompile(ents, nr, pass, ft);
	}
}

function fShowHide(){
	var nt,nr;
	nt		= config.nametrail;
	nr		= nt[nt.length-1][0];
	fLeader( nr);
	macRun();
	config.devicetrail[2] = 1;
	coreShutter(1);
}

function fHelp(cell,cnt){
	if(cnt === 0){
		return;
	}
	d	= document.getElementById("confirm");
	d.innerHTML = "";
	f	= config;
	node = help["graphicManage" + cell.id];
	for(a = 0; a < node.Text.length; a += 1){
		o = document.createElement("p");
		d.appendChild(o);
		o.innerHTML = node.Text[a];
	}
	s = d.style;
	net	= f.columns - f.menucolumns;
	s.left	= - f.colwidth;
	s.top	= document.body.clientHeight/2;
	s.width = f.colwidth * 2;
	s.padding	= "1em";
	s.display = "block"; 
}

function fStyle(node,dt){
	if(!nset[node].Style){
		return;
	}
	cs = nset[node].Style;
	s = [];
	for(n in nset){
		if(!nset[n].Style){
			continue
		}
		s.push(nset[n].Style);
	}
	s.sort();
	lst = "";
	ss = [];
	for(a = 0; a < s.length; a += 1){
		if(s[a] !== lst){
			ss.push(s[a]);
			lst = s[a];
			if(s[a] === cs){
				ind = ss.length-1;
			}
		}
	}	
	dt[1][1] = ind * config.cellheight;
	pan = "dold1";
	corePlainSlider(1 , dt , ss , pan);
}

function fSettings(){

}

function confirmDown(cell){
	var val,nt,node,dt,dc,name,prop,sVal,exst,list,pan;
	val = document.getElementById("inp").innerHTML;
	coreConfirmHide();
	nt		= config.nametrail;
	node	= nt[nt.length-1][0];
	dt		= config.devicetrail;
	dc		= config.devicecontrol; 
	if(dt[0][0] === "Genus"){
		name = val; 
		nset[node].Genus = val;
		dc[1] = val;
		prop = dc[0];  //Type
	}
	else{
		sVal = val.split(" ");
		name = sVal[0]; 
		nset[node].Name = val;
		dc[2]	= val;
		prop	= dc[1];	//Genus
	}
	exst = fExist(name);
	if(exst === 0){
		words = fEntry(name , prop);
	}
	list	 = words[prop].Forelink;
	pan	 = "dold1";
	corePlainSlider( 1 , dt , list , pan );	
	fProperties ( 1 , dt , node );
	if(dt[0][0] === "Name"){
		document.getElementById("n"+node).innerHTML = val;
	}
	config.devicecontrol = dc;
}

function fPrompts(cell,cnt,node){
	var prop,dt,list,sh,nos,a,pan ; 
	prop	= cell.id;
	dt		= config.devicetrail;
	dt[0][0]	= prop;
	coreConfirmHide();
	switch(prop){
		case "Links"	:	
		list = fList("Links");
		dt[1][1] = 0;
		coreLinksList(0 , list , 1 );
		sh = 0;
		break;
		case "Interactors"	:	
		list = fList("Interactors");
		dt[1][1] = Math.round(list.length/2) * config.cellheight;
		coreInteractorsList(0 , list , 1 );	
		sh = 0;
		break;
		case "ShowHide"	:	
		fShowHide();
		sh = 1;
		break;
		case "Style"	:	
		fStyle(node,dt);
		sh = 0;
		break;
		case "Settings"	:
		list = "Camera location,
		
		fSettings(node);
		sh = 0;
		break;
		case "Help"	:	
		list = fList("Help");
		dt[1][1] = 0;
		pan = "dold1";
		corePlainSlider(1 , dt , list , pan);
		sh = 0;
		break;
		case "Menu"		:	sh = 1;		break;
	}
	coreShutter(sh);
	config.devicetrail = dt;
}	

function fInput(dt, name ){
	var count,n,on,sld,o,s;
	if(dt[1][0] === "Name"){
		count = 1;
		for(n in nset){
			if(nset[n].Forelink){
				continue;
			}
			if(nset[n].Name){
				on = nset[n].Name;
				on = on.split(" ");
				if(on[0] === name){
					count += 1;
				}	
			}		
		}
		name = name.split(" ");
		name = [name[0],count].join(" ");
	}
	sld	= document.getElementById("dold1");
	sld.style.top = config.stripetop;
	document.getElementById("inp").innerHTML = name;
	o = document.getElementById("confirm"); 
	s = o.style;
	s.left		= sld.offsetLeft;
	s.top		= sld.offsetTop; 
	s.width		= config.colwidth + "px";
	s.display	= "block";
}

function fOptions(cell,cnt,node){
	var dt,dc;
	dt = config.devicetrail;
	dc = config.devicecontrol;
	if(cnt === 0){
		return;
	}
	switch(dt[0][0]){
		case "Interactors" :
		coreInteractors(cell,cnt);
		break;
		case "Links" :
		coreLinks(cell,cnt);
		cell.className = "dbgc";
		break;
		case "Style"	: fStyleOpts(cell,cnt); break;
		case "Settings"	: fSettingsOpts(cell,cnt); break;
		case "Help"		: fHelp(cell,cnt); break;
		
	}
	coreShutter(0);
	config.devicecontrol = dc;
}	
	
function fInteract(prm){
	var cnt,dt,nt,node;
	cnt		= prm[1];
	dt		= config.devicetrail;
	nt		= config.nametrail;
	node	= nt[nt.length-1][0];
	switch(prm[0]){
		case "Select" :
		interSelect(cnt,node);
		break;
		case "Properties" :
		coreShutter(1);
		fProperties(cnt , dt , node );
		break;
		case "Views" :
		if(prm[1] === 1){
			interViews();
		}
		break;
		case "Hilites" :
		interHilites();
		break;
		case "Rename" :
		interRename(); 
		break;
		case "Sync" :
		interSync();
		break;	
	}
}

function fStart(){
	var cw,cl,d,dt,nt,node,list;
	cw = config.colwidth;
	cl = config.columns;
	d	= document.getElementById("dold");	
	coreSetup(d);
	d	= document.getElementById("dold");
	coreInput(d);							
	coreRun2(cl, cw , d ); 
	dt		= config.devicetrail;
	nt		= config.nametrail;
	node	= nt[nt.length-1][0];
	config.opendevice = "graphicManage";
	list =["deviceInteractors"];
	coreSupportFiles(list); 
	config.active = [["Select"],["Views"],["Hilites"]]; //cnt will be added to each
	config.select = ["Single"];
}

function fFinish(){
	coreCleanup();
	delete config.select;
}