/*
copyright 2010 Chris Glasier 
code check JSLint outstanding
*/

function guidePanel(){
	var d,s;
	d	= document.createElement("div");
	document.body.appendChild(d);
	d.id		= "gold";
	d.className = "pink";
	d.onmousedown = function() { guideDown(this); };
	s			= d.style;
	s.top		= document.body.clientHeight - config.cellheight * 1.5;
	s.width		= document.body.clientWidth + "px";
	s.height	= config.cellheight * 1.5;
}

function guideHand(){
	i = document.createElement("img");
	document.body.appendChild(i);
	i.src			= "cursorHand.png";
	i.id			= "guideCur";
	i.style.display	= "none";
}

function guideStart(name){
	var gd,c,d;
	if(!document.getElementById("gold")){
		guidePanel();
	}
	if(!document.getElementById("guideCur")){
		guideHand();
	}
	config.animate = 800;
	switch(name){
		case "Movement" :
		deviceInitiator("nameNames");
		interViews();
		config.nametrail = [["0",0,"nset"],["1",0,"nset"],["2",0,"nset"],["3",0,"nset"],["4",20,"nset"],["VIEW",240,"nset"]]
		macRun(); 
		interViews();
		rows = document.body.clientHeight/config.cellheight/2 - 1.5;
		gd = [[1,"Movement"]];
		gd.push([[5,rows],[3,2],["n210",5,"nold"],"Clicking to navigate and activate"]);
		gd.push([[3,2],[2,0],["n210",5,"nold"],"Clicking again to invoke action"]);
		gd.push([[2,0],[3,-1],["n85",6,"nold"],"Moving down the trail"]);
		gd.push([[3,2],[3,1],["n156",7,"nold"],"Component is also selected in Sketchup"]);
		gd.push([[3,1],[4,4],["Type",0,"dold"],["Setting name triplet; type set on import"]]);
		gd.push([[4,4],[4,1],["Genus",0,"dold"],["but not genus name"]]);
		gd.push([[4,1],[5,0],["Input",1,"dold"],["opening input box"]]);
		gd.push([[5,0],[5,0],["Inp",1,"dold","Wood"],["Inputting name"]]);
		gd.push([[5,0],[5,0],["Confirm",1,"dold","Wood"],["Clicking &larr; to add name to nset and word store"]]);
		gd.push([[5,1],[3,-3],["n86",7,"nold"],["Inspecting names for other gable"]]);
		gd.push([[3,-3],[4,0],["Genus",0,"dold"],["Opening options"]]);
		gd.push([[4,0],[5,0],["Wood",1,"dold"],["Clicking name from word store"]]);
		gd.push([[5,0],[5,0],["Confirm",1,"dold"],["Clicking &larr; to add stored unique name to nset"]]);
		gd.push([[5,0],[4,-3],["Menu",0,"dold"],["Opening device menu"]]);
		gd.push([[4,-3],[5,-3],["m3",0,"mold"],["Opening Graphic device menu"]]);
		gd.push([[5,-3],[5,0],["m31",1,"mold"],["Opening Import device"]]);
		gd.push([[4,1],[6,0],["Finish"],["Close "+gd[0][1] + " guide"]]);
		config.guide = gd;
		c = document.getElementById("guideCur")
		c.style.left = (gd[1][0][0] - .6) * config.colwidth;
		c.style.top = config.stripetop + gd[1][0][1] * config.cellheight;
		c.style.display = "block";
		d = document.getElementById("gold")
		d.innerHTML = "<span>&uarr;</span> " + gd[1][3];
		break;
	}
}

function guideDown(cell){
	var gd,seq;
	gd = config.guide;
	seq	= gd[0][0];
	guideCursor()
}

function guideCursor(){
	f	= config;
	an	= f.animate;
	ch	= f.cellheight;
	cw	= f.colwidth;
	st	= f.stripetop;
	gd	= f.guide;
	seq = gd[0][0];
	o	= document.getElementById("guideCur");
	lb	= (gd[seq][0][0] - .6) * cw;
	le	= (gd[seq][1][0] - .6) * cw;
	tb	= gd[seq][0][1] * ch + st;
	te	= gd[seq][1][1] * ch + st;
	animate(o, lb, le, tb, te, an, 20, 1);
}	

function run(){
	gd	= config.guide;
	seq = gd[0][0];
	if(gd[seq][2][0] === "Finish"){
		obj = document.getElementById("gold");
		document.body.removeChild(obj);
		obj = document.getElementById("guideCur");
		document.body.removeChild(obj);
		coreShutter(1);
		return;
	}
	switch(gd[seq][2][0]){
		case "Inp" : 
		document.getElementById("inp").innerHTML = gd[seq][2][3]; 
		document.getElementById("guideCur").src = "cursorText.png";
		break;
		case "Confirm" : 
		confirmDown();
		document.getElementById("guideCur").src = "cursorHand.png";	
		break;
		default:
		p	= gd[seq][2];
		cell = document.getElementById(p[0]); 
		coreDown(cell,p[1],p[2]);
	}	
	seq += 1;
	gd[0][0] = seq;
	document.getElementById("gold").innerHTML = "<span>&uarr;</span> " + gd[seq][3];;
}
	
function easeQuadOut(t, b, c, d) {
	return -c * (t/=d)*(t-2) + b;
}

function animate(obj,lBegin, lEnd, tBegin, tEnd, duration, fps, sw) {
	var lChange,tChange,interval,steps,i;
	lChange      = lEnd-lBegin;
	tChange      = tEnd-tBegin;
	interval    = Math.ceil(1000/fps);
	steps		= Math.ceil(duration/interval);
	if(obj.coreStop){
		clearInterval(obj.coreStop);
	}
	i = 0;
    obj.coreStop = setInterval(
	function() { 
		obj.l = easeQuadOut(i, lBegin, lChange, steps);
		obj.t = easeQuadOut(i, tBegin, tChange, steps);
		obj.style.left  = obj.l + 'px'; 
		obj.style.top   = obj.t + 'px'; 
		i+=1;
		if (i > steps){
			clearInterval(obj.coreStop);
			if(sw === 1){
				run();
			}
		}
	} 
	,interval);
}
