/*machine - Start at page bottom 
copyright 2010 Chris Glasier 
coding advice by Jim Foltz
JSLint code check */
var config , mset , nset;

function macRunTops(cw, tt, pan, st){
	var c, d;
	for(c = 0; c < tt.length; c+=1){
		d = document.getElementById(pan+c).style;
		d.left	= c * cw + "px";
		d.top	= st - tt[c][1] + "px";
		d.width	= cw + "px";		
	}
}		

function macResize(){
	var f,cl,cw,lf,nt,mc,mt,dt,od,st,node,nnt,nl,dev;
	f = config;
	cl	= f.columns;
	cw	= f.colwidth;
	lf	= f.left;
	nt	= f.nametrail;
	mc	= f.menucolumns;
	mt	= f.menutrail;
	dt	= f.devicetrail;
	cw	= Math.round(document.body.clientWidth / cl);
	config.colwidth = cw;
	st	= Math.round(document.body.clientHeight / 2);
	config.stripetop = st;
	node = nt[nt.length-1][0];
	if(nset[node].Forelink){
		nnt = nt;
	}
	else {
		nnt = nt.slice(0,-1);
	}
	if(nnt.length <= cl - mc){
		nl = 0;
	}
	else{
		nl = nnt.length - (cl - mc);
	}
	document.getElementById("nold").style.left = nl * -cw;
	macRunTops(cw, nnt, "nold", st);
	document.getElementById("mold").style.left	= cw * (cl - mc);
	document.getElementById("mold").style.width	= cw * mc;
	macRunTops(cw, mt, "mold", st);
	if(config.opendevice){
		dev = document.getElementById("dold");
		coreLayout(cl , cw , dev , dt);
	}	
}

function macSliderHolder(c , cw , tt, pan, st){
	var t = st - tt[c][1];
	coreSliderHolder(c , cw , pan, t);
}

function macSlider(c , cl , cw , mc , nm, tt, pan , st){
	var list;
	list = nm[tt[c][0]].Forelink; 
	coreNsetSlider(list , pan , c , nm , tt);
}
		
function macSliderLeft(c, cl, cw , mc , nm , tt , pan ){	
	var left,lst,obj,elm,start,fin; 
	if(tt.length > cl - mc){
		left = tt.length - (cl - mc);
	}
	else{
		left = 0;
	}
		lst		= tt[tt.length-1];
	if(nm[lst[0]].Forelink === undefined && tt.length > cl - mc ){
		left -= 1; 
	}
	left	= left * cw;
	obj		= document.getElementById(pan);
	elm		= "left";
	start	= parseInt(obj.style.left,10);
	fin		= -left;
	coreAnimate(obj , elm , start , fin , 300, 20, 0 );
}

function macRun(){
	var f,c,ch,cl,cw,mt,mc,nt,st,x,pan; 
	f	= config;
	ch	= f.cellheight;
	cl	= f.columns;
	mt	= f.menutrail; 
	mc	= f.menucolumns;
	nt	= f.nametrail;
	cw	= document.body.clientWidth / cl;
	st	= Math.round(document.body.clientHeight/2);
	document.getElementById("nold").style.left  = 0;    //for restore
	document.getElementById("nold").innerHTML = "";
	config.colwidth		= cw;
	config.stripetop	= st;
	for(c = 0 ; c < nt.length ; c+=1){					//name
		pan = "nold";
		macSliderHolder(c , cw , nt, pan, st);
		macSlider(c, cl , cw , mc ,nset,  nt , pan, st);
	} 
	macSliderLeft(0 , cl, cw , mc , nset, nt , pan ); 
	if(config.opendevice){
		return;
	}
	x	= document.getElementById("mold").style;
	x.left		= (cl - mc) * cw + "px";
	x.width		= mc * cw + "px";
	x.height	= "100%";
	for(c = 0 ; c < mt.length ; c+=1){				//menu
		pan = "mold";
		macSliderHolder(c , cw , mt, pan, st);
		macSlider(c , cl , cw , mc , mset, mt, pan , st);
	}
	
}

function macRefresh(cnt,dv){
	if(config.active){
		for(a = 0; a < config.active.length; a += 1){
		config.active[a][1] = cnt;
			fInteract(config.active[a])
		}
	}
}

function noldDown(params){					//params = cell ,  sliderName , sliderNo , cnt , fin
	var a, cnt, cl, cplt, cw, f, fin, json, mc, node, nt, pan, sName, sNo, nNo, st, hold, coll;
	f		= config;
	ch		= f.cellheight;
	cl		= f.columns;
	cw		= f.colwidth;
	mc		= f.menucolumns;
	nt		= f.nametrail;
	st		= f.stripetop;
	cell	= params[0];
	node	= cell.id.slice(1);
	sName	= params[1];
	sNo		= params[2];
	cnt		= params[3];
	fin		= params[4]; 
	pan		= "nold";
	nNo		= sNo + 1; 
	dv		= "nold";
	lst		= nt[nt.length-1][0]
	
	if(sNo < nt.length-1){
		nt		= nt.slice(0,nNo);
		if(nset[node].Forelink){
			par		= cell.parentNode.parentNode;
			coll	= par.childNodes;
			if(nt.length < cl - mc){
				for(a = sNo+1; a<coll.length; a += 1){
					obj = coll[a];
					par.removeChild(obj);
				}
			}
		}
	}
	nt[nt.length-1][1] = st - fin;
	cplt	= [node,0,nt[nt.length-1][2]];  //parent, pxs above stripe for next
	nt.push (cplt);
	config.nametrail = nt;
	macRefresh(cnt,dv);
	if(nset[node].Forelink){
		nt[nt.length-1][1] = Math.floor(nset[node].Forelink.length/2) * ch; 
		macSliderHolder(nNo , cw , nt, pan, st); 
		macSlider(nNo , cl , cw , mc , nset , nt, pan);
		next = document.getElementById(pan+nNo);
		offset = Math.floor(nset[node].Forelink.length/2) * ch;
		next.style.top = st - offset + "px"; 
	}
	macSliderLeft(sNo, cl, cw , mc , nset, nt , pan);
	if(nset[node].Type === "Header"){
		rubyChange(node);
	}
}
	
function mold0Down(params){	//params = cell ,  sliderName , sliderNo , cnt , fin
	var f,mt,node,st,list;
	f = config;
	mt		= f.menutrail;
	node	= params[0].id.slice(1);
	if(mset[node].Name === "Save"){
		if(params[3] === 0){
			document.getElementById("mold1").innerHTML = "";
		}
		else{
			macFinish();
		}
		return;
	}
	st	= Math.round(document.body.clientHeight/2);
	document.getElementById("mold1").style.top = st +"px";
	mt[0][1] =  st - params[4];
	mt[1] = [node,0];
	config.menutrail = mt; 
	list	= mset[node].Forelink; 
	coreNsetSlider(list , "mold", 1, mset , mt); 
	if(f.opendevice){
		fFinish();				
		delete f.opendevice;
	}
}

function deviceInitiator(args){
var holder,obj; 
	holder = document.getElementById("deviceScript");
	holder.innerHTML = "";
	obj = document.createElement("script");
	holder.appendChild(obj);
	obj.Type = "text/javascript";
	obj.src = args + ".js";
	fStart();
}	

function mold1Down(params){
	var f,mt,node,st,lst,mid,name,args;
	f = config;
	mt		= f.menutrail;
	node	= params[0].id.slice(1);
	st		= Math.round(document.body.clientHeight/2);
	mt[1][1]= st - params[4];
	config.menutrail = mt;	
	lst		= mt[1][0]; 
	mid		= mset[lst].Name;
	name	= mset[node].Name;
	if(mid === "Guide"){
		guideStart(name);
		return;
	}
	if(params[3] === 1){
		args = mid.toLowerCase()+name;
		if(deviceInitiator(args)){
			deviceInitiator(args);
		}
	}
}

function moldDown(params){	
	if(params[2] === 0){
		mold0Down(params);
	}
	else{
		mold1Down(params);
	}
}function tracer(){
	w = window.open("","w","width=200,height=400, scrollbars=yes,resizable=yes");
}

function call(val){
		w.document.write(val+"<br>");
}





