/*
nameNames -Start at page bottom 
copyright 2010 Chris Glasier 
code check JSLint 2 March 2010
*/

/*global config,nset,mset,words,numbers,corePlainSlider,coreConfirmHide,macRun,coreLength,coreInteractors,coreLinks,coreLinksList,coreInteractorsList ,coreShutter,interSelect,interViews,interHilites,interRename,interSync,coreSetup,coreRun2,coreInput,coreSupportFiles,coreCleanup 
*/

function fExist(name){
	var exst,a;
	exst = 0;
	for(a in words){
		if(!words[a].Forelink){
			continue;
		}
		if(words[a].Name === name){
			exst = 1;
		}
	}
	return(exst);
}

function fEntry(name , prop){
	var o,dt;
	dt = config.devicetrail;
	o = {};						
	o.Name = name;
	o.Forelink = ["Input"];
	words[prop].Forelink.splice(1,0,name);
	words[name] = o;
	return(words);
}

function fList(name){
var list;	
	switch(name){
	case "Main"		: list = ["Links","Interactors","Headers","New","Backlinks","Menu","Sort","Delete"]; break;
	case "Links"		: list = ["Single","Block","Multiple","Change link","Cross link","Cancel"]; break;
	case "Interactors"	: list = ["Views","Hilites","Sync","Rename"]; break;
	case "New"		: list = ["Slider","Cell"]; break;
	case "Sort"		: list = ["A-Z","Z-A","Visibility","Up","Down","Reset","Save"]; break;
	case "Delete"		: list = ["Confirm","Cancel"]; break;
	}
	return(list);
}

function fProperties (cnt , dt , node  ){
	var list0,n,list1,list,pan;
	list0 = fList("Main");
	n = nset[node];
	list1 = [["Type",n.Type],["Genus",n.Genus],["Name",n.Name]];
	list = list0.concat(list1);
	config.devicecontrol = [n.Type,n.Genus,n.Name];
	pan = "dold0";
	corePlainSlider(0 , dt , list , pan);
}

function confirmDown(){
	var val,nt,node,dt,dc,name,prop,sVal,exst,list,pan;
	
	val = document.getElementById("inp").innerHTML;
	coreConfirmHide();
	nt		= config.nametrail;
	node	= nt[nt.length-1][0];
	dt		= config.devicetrail;
	dc		= config.devicecontrol; 
	if(dt[0][0] === "Headers"){
		fHeaders(val, nt, node, dt);
		return;
	}
	if(dt[0][0] === "Genus"){
		name = val; 
		nset[node].Genus = val;
		dc[1] = val;
		prop = dc[0];  //Type
	}
	else{
		sVal = val.split(" ");
		name = sVal[0]; 
		nset[node].Name = val;
		dc[2]	= val;
		prop	= dc[1];	//Genus
	}
	exst = fExist(name);
	if(exst === 0){
		words = fEntry(name , prop);
	}
	list	 = words[prop].Forelink;
	pan	 = "dold1";
	corePlainSlider( 1 , dt , list , pan );	
	fProperties ( 1 , dt , node );
	if(dt[0][0] === "Name"){
		document.getElementById("n"+node).innerHTML = val;
	}
	config.devicecontrol = dc;
}

function fHeaders(val, nt, node, dt){
	var obj, tp;
	if(!nset[node].Forelink){
		nset[node].Forelink = [];
	}
	obj = {};
	obj.Type	= "Header"; 
	obj.Genus	= "xxx";
	obj.Name	= val;
	obj.Backlink = [node];
	nset[val] = obj; 
	nset[node].Forelink.push(val);
	tp = Math.round(nset[node].Forelink.length - 1) * config.cellheight;
	nt[nt.length-1][1] = tp;
	macRun();
}	

function fNew(cell,cnt){
	var nt,node,prop,lgth,obj,tmp,tp;
	nt = config.nametrail;
	node = nt[nt.length-1][0];
		if(nset[node].Type === "Item"){
		nt = nt.slice(0,-1);
		config.nametrail = nt;
		macRun();
		return;
	}
	prop = cell.id;
	lgth = coreLength();
	lgth = lgth.toString();
	obj = {};
	obj.Type	= "Type"; 
	obj.Genus	= "xxx";
	obj.Name	= "xxx";
	obj.Backlink = [node];
	nset[lgth] = obj; 
	if(prop === "Slider"){
		tmp = nset[node].Forelink;
		nset[node].Forelink = [lgth];
		obj.Forelink = tmp;
		nt[nt.length-1][1] = 0;
	}
	else{
		if(!nset[node].Forelink){
			nset[node].Forelink = [];
		}
		nset[node].Forelink.push(lgth);
		tp = Math.round(nset[node].Forelink.length - 1) * config.cellheight;
		nt[nt.length-1][1] = tp ;
	}
	
	macRun();
}	

function fBacklinks(cell,cnt){
	var src,par,nt,ind,pind,list,a;
	if(cnt === 0){
		return;
	}
	src		= cell.id.slice(1);
	par		= nset[src].Backlink[0];
	nt		= config.nametrail;
	for(a = 0; a < nt.length; a += 1){
		if(nt[a][0] === par){
			pind = a;
		}
	}
	list = nset[par].Forelink;
	for(a = 0; a < list.length; a += 1){
		if(list[a] === src){
			ind = a;
		}
	}
	nt[pind][1]		= ind * config.cellheight;
	config.nametrail = nt;
	macRun();
}
	
function fSort(cell,cnt){	
	if(cnt === 0){
		return;
	}
	var nt,node,pNode,par,coll,sw,names,a,obj,ind,vis,hid,list,old,nos,lab;
	nt		= config.nametrail;
	node	= nt[nt.length-1][0];
	pNode	= nt[nt.length-2][0];
	par		= document.getElementById("n" + node).parentNode; 
	coll	= par.childNodes;
	if(cell.id === "A-Z" || cell.id === "Z-A"){
		sw = "AZZA";
	}
	else if(cell.id === "Up" || cell.id === "Down"){
		sw = "UD";
	}
	else{
		sw	= cell.id;
	}
	switch(sw){
		case "AZZA" :
		names	= [];
		for(a = 0; a < coll.length; a += 1){
			names.push([coll[a].innerHTML, coll[a]]);
		}
		names.sort();
		if(cell.id === "Z-A"){
			names.reverse();
		}
		par.innerHTML = "";
		for(a = 0; a < names.length; a += 1){
			obj =	names[a][1];
			par.appendChild(obj);
			obj.innerHTML = names[a][0];
			if(obj.id === "n"+node){
				ind = a;
				obj.className = "nbgc";
			}
			else{
				obj.className = "nbdr";
			}
		}
		par.style.top = (config.stripetop - ind * config.cellheight) + "px";
		break;
		case "Visibility" :
		vis	= [];
		hid	= [];
		for(a = 0; a < coll.length; a += 1){
			if(!coll[a].style.textDecorationLineThrough){
				vis.push([coll[a].innerHTML, coll[a]]);
			}
			else{
				hid.push([coll[a].innerHTML, coll[a]]);
			}
		}
		list = vis.concat(hid);
		par.innerHTML = "";
		for(a = 0; a < list.length; a += 1){
			obj =	list[a][1];
			par.appendChild(obj);
			obj.innerHTML = list[a][0];
			if(obj.id === "n"+node){
				ind = a;
				obj.className = "nbgc";
			}
			else{
				obj.className = "nbdr";
			}
		}
		par.style.top = (config.stripetop - ind * config.cellheight) + "px";
		break;
		case "UD" :
		for(a = 0; a < coll.length; a += 1){
			if(coll[a].id === "n" + node){
				obj = coll[a];
				if(cell.id === "Up"){
					ind	= a - 1;
				}
				else{
					ind = a + 1;
				}
			}
		}
		par.removeChild(obj);
		old = coll[ind];
		par.insertBefore(obj,old);
		par.style.top = (config.stripetop - ind * config.cellheight) + "px";
		break;
		case "Reset"	: macRun();	break;
		case "Save"	:
		nos = [];
		for(a = 0; a < coll.length; a += 1){
			lab = coll[a].id.slice(1);
			lab = lab.toString();
			nos.push(lab);
		}
		nset[pNode].Forelink = nos;
		macRun();		//to indicate saved
		break;
		}
}	
		
function fDelete(cnt , dt , node ){
	if(cnt === 0){
		return;
	}
	var nt,par,list,o,n,ind;
	config.devicetrail[2] = 1;
	nt		= config.nametrail;
	node	= nt[nt.length-1][0];
	if(node === "1"){			//Start
		return;
	}
	par		= nt[nt.length-2][0];
	nset[node].Deleted = 1;
	list	= nset[par].Forelink; 
	o = 0;
	for(n in list){
		if(list[n] === node){
			ind = o;
		}
	o += 1;
	}
	list.splice(ind,1);
	if(nset[par].Forelink.length === 0){
		delete nset[par].Forelink;
	}
	else{
		nset[par].Forelink = list;
	}
	document.getElementById("n"+node).style.color = "pink";
}	

function fType (cnt , dt , node ){
	var list0,list,a,pan;
	list0	= words.All.Forelink; 
	list = [];
	for(a = 0; a < list0.length; a += 1){
		list.push(words[list0[a]].Name);
	}
	pan = "dold1";
	dt[1][1] = Math.floor(list.length/2)*config.cellheight;
	corePlainSlider(1, dt , list , pan);
}

function fGenus (cnt , dt , node ){
	if(nset[node].Genus === "xxx"){
		return;
	}
	var prop,list0,list,a,pan;
	config.devicetrail[2] = 0;
	prop	= config.devicecontrol[0];
	if(!words[prop]){
		list0 = ["Input"];
	}
	else{
		list0 = words[prop].Forelink;
	}
	list = [];
	for(a = 0; a < list0.length; a +=1){
		list.push(words[list0[a]].Name);
	}
	pan = "dold1";
	dt[1][1] = Math.floor(list.length/2)*config.cellheight;
	corePlainSlider(1, dt , list , pan);
}

function fName (cnt , dt , node ){
	var prop,list0,list,a,pan;
	prop	= config.devicecontrol[1]; 
	if(!words[prop]){
		list0 = ["Input"];
	}
	else{
		list0 = words[prop].Forelink;
	}
	list = [];
	for(a = 0; a < list0.length; a += 1){
		list.push(words[list0[a]].Name);
	}
	pan = "dold1";
	dt[1][1] = Math.floor(list.length/2)*config.cellheight;
	corePlainSlider(1, dt , list , pan);
}

function fPrompts(cell,cnt,node){
	var prop,dt,list,sh,nos,a,pan ; 
	prop	= cell.id;
	dt		= config.devicetrail;
	dt[0][0]	= prop;
	coreConfirmHide();
	switch(prop){
		case "Links"	:	
		list = fList("Links");
		dt[1][1] = 0;
		coreLinksList(0 , list , 1 );
		sh = 0;
		break;
		case "Interactors"	:	
		list = fList("Interactors");
		dt[1][1] = Math.round(list.length/2) * config.cellheight;
		coreInteractorsList(0 , list , 1 );	
		sh = 0;
		break;
		case "Headers"	:
		list = [];
		for(n in nset){
			if(nset[n].Type === "Header"){
				list.push(nset[n].Name);
			}
		}
		list.sort();
		list.unshift("Input");
		dt[1][1] = Math.round(list.length/2) * config.cellheight;
		pan = "dold1";
		corePlainSlider(1 , dt , list , pan);
		sh = 0;
		break;
		case "New"	:	
		list = fList("New");
		dt[1][1] = Math.round(list.length/2) * config.cellheight;
		pan = "dold1";
		corePlainSlider(1 , dt , list , pan);
		sh = 0;
		break;
		case "Backlinks"	:	
		nos = nset[node].Backlink;
		list = [];
		for(a =0; a<nos.length; a += 1){
			list.push(["d"+nos[a], nset[nos[a]].Name]);
		}
		dt[1][1] = 0;
		pan = "dold1";
		corePlainSlider(1 , dt , list , pan);
		sh = 0;
		break;
		case "Sort"	:	
		list = fList("Sort");
		dt[1][1] = 0;
		pan = "dold1";
		corePlainSlider(1 , dt , list , pan);
		sh = 0;
		break;
		case "Delete"	:	
		list = fList("Delete");
		dt[1][1] = 0;
		pan = "dold1";
		corePlainSlider(1 , dt , list , pan);
		sh = 0;
		break;
		case "Menu"		:	sh = 1;								break;
		case "Type"		:	fType(cnt , dt , node  ); sh = 0;	break;
		case "Genus"	:	fGenus(cnt , dt , node ); sh = 0;	break;
		case "Name"		:	fName(cnt , dt , node ); sh = 0;	break;
		
	}
	coreShutter(sh);
	config.devicetrail = dt;
}	

function fInput(dt, name ){
	var count,n,on,sld,o,s;
	if(dt[1][0] === "Name"){
		count = 1;
		for(n in nset){
			if(nset[n].Forelink){
				continue;
			}
			if(nset[n].Name){
				on = nset[n].Name;
				on = on.split(" ");
				if(on[0] === name){
					count += 1;
				}	
			}		
		}
		name = name.split(" ");
		name = [name[0],count].join(" ");
	}
	sld	= document.getElementById("dold1");
	sld.style.top = config.stripetop;
	document.getElementById("inp").innerHTML = name;
	o = document.getElementById("confirm"); 
	s = o.style;
	s.left		= sld.offsetLeft;
	s.top		= sld.offsetTop; 
	s.width		= config.colwidth + "px";
	s.display	= "block";
}

function fOptions(cell,cnt,node){
	var dt,dc;
	dt = config.devicetrail;
	dc = config.devicecontrol;
	if(cnt === 0){
		return;
	}
	switch(dt[0][0]){
		case "Interactors" :
		coreInteractors(cell,cnt);
		break;
		case "Links" :
		coreLinks(cell,cnt);
		cell.className = "dbgc";
		break;
		case "New"		: fNew(cell,cnt);		break;
		case "Backlinks": fBacklinks(cell,cnt);	break;
		case "Sort"		: fSort(cell,cnt);		break;
		case "Delete"	: fDelete(cell,cnt);	break;
		case "Type"	:
		dc[0]	= cell.id;
		nset[node].Type = dc[0];
		if(nset[node].Genus === "xxx"){
			nset[node].Genus = "Genus";
		}
		cell.className = "dbdr";
		fProperties (1 , dt , node);
		break;
		case "Genus"	:
		if(cell.id === "Input"){
			name = "";
		}
		else{
			name = cell.id;
			dc[1] = cell.id;
		}
		cell.className = "dbdr";
		fInput(dt, name);
		break;
		case "Name"	: 
		if(cell.id === "Input"){
			name = dc[1];
		}
		else{
			name = cell.id;
		}
		cell.className = "dbdr";
		fInput(dt, name);
		break;
		case "Headers" :
		if(cell.id === "Input"){
			cell.className = "dbdr";
			name = "New";
			fInput(dt, name);
		}
		else{
			alert("not done");
		}
	
	}
	coreShutter(0);
	config.devicecontrol = dc;
}	
	
function fInteract(prm){
	var cnt,dt,nt,node;
	cnt		= prm[1];
	dt		= config.devicetrail;
	nt		= config.nametrail;
	node	= nt[nt.length-1][0];
	switch(prm[0]){
		case "Select" :
		interSelect(cnt,node);
		break;
		case "Properties" :
		coreShutter(1);
		fProperties(cnt , dt , node );
		break;
		case "Views" :
		if(prm[1] === 1){
			interViews();
		}
		break;
		case "Hilites" :
		interHilites();
		break;
		case "Rename" :
		interRename(); 
		break;
		case "Sync" :
		interSync();
		break;	
	}
}

function fStart(){
	var cw,cl,d,dt,nt,node,list;
	cw = config.colwidth;
	cl = config.columns;
	d	= document.getElementById("dold"); 
	coreSetup(d);
	coreInput(d);
	coreRun2(cl, cw , d );
	dt		= config.devicetrail;
	nt		= config.nametrail;
	node	= nt[nt.length-1][0];
	fProperties(1 , dt , node );
	config.opendevice = "nameNames";
	list =["deviceInteractors"];
	coreSupportFiles(list);
	config.active = [["Select"],["Properties"],["Views"],["Hilites"]]; //cnt will be added to each
	config.select = ["Single"];
}

function fFinish(){
	coreCleanup();
	delete config.devicecontrol;
}