/*nameCells -Start at page bottom 
copyright 2010 Chris Glasier 
coding advice by Jim Foltz
JSLint code check */

function fOne2RunOff(nr, type, word){
	var runOff, n, mch, cut;
		runOff = [];
	for (n in nset){
		if(nset[n].Deleted === 1 || nset[n] === nr){
			continue;
		}
		if(!nset[n].Name || !nset[n].Genus){
			continue;
		}
		switch(type){
			case "Genus"	: mch = nset[n].Genus;	break;
			case "Name"	: mch = nset[n].Name;	break;
			default	:
			cut = nset[n].Name;
			cut = cut.split(" ");
			mch = cut[0];
		}
		if(word === mch){
			runOff.push(n);
		}
	}
	return runOff; 
}

function fPass(ents, nr, pass, ft){
	var nt,fn;
	pass += 1;
	if(ents[pass] === undefined){
		return;
	}
	nr = ents[pass];
	if(nset[nr].Forelink){
		fCompile(ents , nr , pass, ft);
	}
	else{
		fPass(ents, nr, pass, ft);
	}
}

function fCompile(ents, nr, pass, ft){
	var cell, k, kk;
	nr	= ents[pass];
	k	= nset[nr].Forelink; 
	for(kk = 0; kk < k.length; kk += 1){
		cell = document.getElementById("n"+k[kk]);
		if(ft === 1){
			nset[k[kk]].Filter = "Filtered";
		}
		else{
			delete nset[k[kk]].Filter;
		}	
		ents.push(k[kk]);
	}
	fPass(ents,  nr, pass, ft);
}

function fLeader( nr, nt){
	var ents, pass, cell, ft;
	pass = 0;
	ents = [nr]; 
	cell = document.getElementById("n"+nr);
	ents[pass] = [nr]; 
	if(!nset[nr].Filter){
		nset[nr].Filter = "Filtered";
		ft = 1;
	}
	else{
		delete nset[nr].Filter;
		ft = 0;
	}	
	if(!nset[nr].Forelink){
		nt = config.nametrail;
		fn = nt[nt.length-1][2];
		coreJsonSave(fn + ".json", nset);
		return;
	}
	else{
		fCompile(ents, nr, pass, ft);
	}
}

function fShowHide(){
	var nt,nr;
	nt		= config.nametrail;
	nr		= nt[nt.length-1][0];
	fLeader( nr);
	macRun();
	config.devicetrail[2] = 1;
	coreShutter(1);
}

function fEntry(old, lab, blnk){
	var obj;
	obj = {};
	obj.Type	= old.Type;
	obj.Genus	= old.Genus;
	obj.Name	= old.Name;
	obj.Backlink = [blnk];
	return(obj);
}

function fOne2Compile(ents, pass){
	var nr, lgth, blnk, old, lab, obj, nObj, k, kk;
	nr		= ents[pass][0];
	lgth	= ents[pass][1];
	blnk	= ents[pass][2];
	old		= nset[nr];
	lab		= lgth.toString();
	obj		= fEntry(old, lab, blnk);
	nset[lab] = obj;
	nObj = nset[lab];
	blnk = lab;
	if(old.Forelink){
		nObj.Forelink = [];
		lgth = coreLength(nset);
		k = old.Forelink; 
		for(kk = 0; kk < k.length; kk += 1){
			lab = lgth.toString();
			nObj.Forelink.push(lab);
			old = nset[k[kk]];
			obj = fEntry(old, lab, blnk);
			nset[lab] = obj;
			ents.push([k[kk],lgth,blnk]);
			lgth = coreLength();
		}	
	}
	pass += 1;
	if(ents[pass] === undefined){
		return;
	}
	 fOne2Compile(ents, pass);
}

function fOne2(nr, blnk){
	var ents, lgth, pass, old, lab, obj;
	pass = 0;
	lgth = coreLength();
	ents = []; 
	ents[pass] = [nr, lgth, blnk]; //alert(JSON.stringify(nset))
	if(!nset[nr].Forelink){
		if(!nset[blnk].Forelink){
			nset[blnk].Forelink = [];
		}
		nset[blnk].Forelink.push(lgth);
		old = nset[nr];
		lab = lgth.toString();
		obj = fEntry(old, lab, blnk);
		nset[lab] = obj;
	}
	else{
		lab	= (lgth).toString();
		nset[blnk].Forelink.push(lab);
		fOne2Compile(ents, pass);
	}
}

function confirmDown(cell){
	var sw, val, type, word, runOff, nf, nr, nt, par, fn, c, a;
	val		= document.getElementById("inp").innerHTML;
	sw		= config.devicetrail[0][0];
	nt		= config.nametrail;
	par		= nt[nt.length-2][0];
	nr		= nt[nt.length-1][0];
	if(sw === "One2Many"){
		type = val.charAt(0);
		word = val.slice(1);
		switch(type){
			case "g" : type = "Genus";	break;
			case "n"	: type = "spt";		break;
			case "i"	: type = "Name";		break;
		}
		runOff = fOne2RunOff(nr, type, word);
		c = runOff.length; 
	}
	else{
		c = val;
	}
	for(a=0; a < c; a+=1){
		if(sw === "Many2One"){
		//alert(nset[par].Forelink);
			nf = nset[par].Forelink;
			nr = nf[nf.length-1];
		}
		else{
			par = runOff[a];
		}
	fOne2(nr, par);
		
	}
	macRun();
	config.devicetrail[2] = 1;
	coreShutter(1);
	coreConfirmHide();
}

function fSave(cell){
	var fn, list, exst, a, dt, pan, nr;
	nr = document.getElementById("inp").innerHTML;
	list = numbers.All;
	exst = 0;
	for(a in list){
		if(list[a] === nr){
			exst = 1;
		}
	}
	if(exst === 0 && isNaN(nr) === false){
		dt = config.devicetrail;
		list.splice(1,0,nr);
		numbers.All = list;
		list = fList("Many2One");
		pan = "dold1";
		corePlainSlider(0 , dt , list , pan);
	}
}
	
function fOne2Many(){
	var nt,node,o,spt,list;
	nt = config.nametrail;
	node = nt[nt.length-2][0];
	o = nset[node];
	spt = o.Name.split(" "); 
	if(o.Genus === spt[0] && o.Name === spt[0]){
		list = ["n"+spt[0]];
	}
	if(o.Genus === spt[0] && o.Name !== spt[0]){
		list = ["n"+spt[0],"i"+o.Name];
	}
	if(o.Genus !== spt[0] && o.Name !== spt[0]){
		list = ["g"+o.Genus,"n"+spt[0],"i"+o.Name];
	}
	if(o.Genus !== spt[0] && o.Name === spt[0]){
		list = ["g"+o.Genus,"i"+o.Name];	
	}
	list.splice(0,0,"Input"); 
	return(list);
}

function fMany2One(){
	var list; 
	list = numbers.All; 
	return(list);
}

function fList(name){
	var list; 
	switch(name){
		case "Main" : 
		list = ["Many2One","One2Many","ShowHide","Jump","Back"];
		break;
		case "Many2One": list = fMany2One();		break;
		case "One2Many": list = fOne2Many();		break;
		case "ShowHide":	fShowHide();			break;
		case "Jump":		/*fJump();*/			break;
		case "Back":		coreShutter(1);			break;
	}		
	return(list);
}

function fPrompts(cell,cnt,node){
	name = cell.id;
	d	= document.getElementById("s").style;
	i	= document.getElementById("inp").style;
	if(name === "One2Many"){
		d.display = "none";
		i.width = "75%";
		i.textAlign = "left";
	}
	else{
		d.display = "block";
		i.width = "50%";
		i.textAlign = "right";
	}
	dt = config.devicetrail;
	list = fList(name); 
	if(list){
		config.devicetrail[2] = 0;
		coreShutter(0);
		pan = "dold1";
		corePlainSlider(1, dt, list , pan);	
	}
}

function fInput(prop){
	var sld, o, s;
	sld	= document.getElementById("dold1");
	sld.style.top = config.stripetop;
	document.getElementById("inp").innerHTML = prop;
	o = document.getElementById("confirm"); 
	s = o.style;
	s.left		= sld.offsetLeft;
	s.top		= sld.offsetTop; 
	s.width		= config.colwidth + "px";
	s.display	= "block";
}

function fOptions(cell,cnt,node){
	fInput(prop);
}
	
function coreInputPlus(dev){		// input/confirm
	var p,s;
	document.getElementById("inp").style.width = "50%";
	document.getElementById("ok").style.width = "25%";
	p = document.createElement("div");
	document.getElementById("confirm").appendChild(p);
	p.id = "s"; p.innerHTML = "&darr;"; p.onmousedown = function() { fSave(p); };
	s = p.style;  s.left = "50%"; s.width = "25%"; s.textAlign = "center";
}

function fStart(){
	var f, ch, cl, cw, mc, nt, st, o, s, dev;
	cw = config.colWidth;
	cl = config.columns;
	d	= document.getElementById("dold");
	coreSetup(d);
	config.opendevice = "nameCells";
	coreInput(d); 
	coreInputPlus(d);
	coreRun2(cl, cw , d );
	
}

function fFinish(){
	coreCleanup();
}